use CorpDB;
go

----------------------------------------------------------------------------------------------------
-- Execution plan is different between estimated and actual
----------------------------------------------------------------------------------------------------
if object_id('tempdb.dbo.#Names') is not null
	drop table #Names;
create table #Names (CustomerId int primary key, LastName nvarchar(50));
go

insert #Names (CustomerId, LastName)
select c.CustomerID, c.LastName from dbo.Customer c;

create nonclustered index idx1_Names__LastName on #Names (LastName);

select CustomerId, LastName
from #Names
where LastName = 'Perez';
go

----------------------------------------------------------------------------------------------------
-- Cannot obtain an estimated execution plan
----------------------------------------------------------------------------------------------------
if object_id('tempdb.dbo.#Orders') is not null
	drop table #Orders;
go

select top (1000) OrderId, OrderDate, CustomerId
into #Orders
from dbo.OrderHeader oh
where oh.OrderDate >= '2016-01-01';

select CustomerId, count(OrderId) NumberOfOrders
from #Orders
group by CustomerId;
