use CorpDB;
go

----------------------------------------------------------------------------------------------------
-- First, create the following function
----------------------------------------------------------------------------------------------------
drop function if exists dbo.GetLine1ProductIdMSTVF
go

create function dbo.GetLine1ProductIdMSTVF (@OrderId int)
returns @productLine table
(
	Line1ProductId int
)
as
begin
	insert @productLine (Line1ProductId)
	select top 1 od.ProductId
	from dbo.OrderDetail od
	where od.OrderId = @OrderId
	order by od.OrderDetailId;

	return
end
go

----------------------------------------------------------------------------------------------------
-- Now get an ACTUAL execution plan on this statement.
-- Note the cost of the overall plan and the cost of the TVF operator
----------------------------------------------------------------------------------------------------
select oh.OrderId,
	oh.OrderDate,
	oh.CustomerId,
	od.Line1ProductId
from dbo.OrderHeader oh
outer apply dbo.GetLine1ProductIdMSTVF (oh.OrderId) od
where oh.OrderDate >= '2016-05-10';

----------------------------------------------------------------------------------------------------
-- Then get an ESTIMATED execution plan on the same statement.
----------------------------------------------------------------------------------------------------
select oh.OrderId,
	oh.OrderDate,
	oh.CustomerId,
	od.Line1ProductId
from dbo.OrderHeader oh
outer apply dbo.GetLine1ProductIdMSTVF (oh.OrderId) od
where oh.OrderDate >= '2016-05-10';
